# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MetaData(BaseModel):
    """
    MetaData
    """ # noqa: E501
    id: StrictStr = Field(alias="_id")
    provider_md_id: Optional[StrictStr]
    provider_id: Optional[StrictStr]
    content: Optional[StrictStr]
    content_type: Optional[StrictStr] = 'text'
    relationships: Optional[List[StrictStr]] = None
    data: Optional[List[StrictStr]] = None
    access: Optional[StrictStr] = 'public'
    unique_name: StrictStr
    data_users: Optional[List[StrictStr]] = None
    sessions: Optional[List[StrictStr]] = None
    create_ts: datetime
    modify_ts: datetime
    __properties: ClassVar[List[str]] = ["_id", "provider_md_id", "provider_id", "content", "content_type", "relationships", "data", "access", "unique_name", "data_users", "sessions", "create_ts", "modify_ts"]

    @field_validator('content_type')
    def content_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['json', 'text']):
            raise ValueError("must be one of enum values ('json', 'text')")
        return value

    @field_validator('access')
    def access_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['public', 'private']):
            raise ValueError("must be one of enum values ('public', 'private')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MetaData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if provider_md_id (nullable) is None
        # and model_fields_set contains the field
        if self.provider_md_id is None and "provider_md_id" in self.model_fields_set:
            _dict['provider_md_id'] = None

        # set to None if provider_id (nullable) is None
        # and model_fields_set contains the field
        if self.provider_id is None and "provider_id" in self.model_fields_set:
            _dict['provider_id'] = None

        # set to None if content (nullable) is None
        # and model_fields_set contains the field
        if self.content is None and "content" in self.model_fields_set:
            _dict['content'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MetaData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_id": obj.get("_id"),
            "provider_md_id": obj.get("provider_md_id"),
            "provider_id": obj.get("provider_id"),
            "content": obj.get("content"),
            "content_type": obj.get("content_type") if obj.get("content_type") is not None else 'text',
            "relationships": obj.get("relationships"),
            "data": obj.get("data"),
            "access": obj.get("access") if obj.get("access") is not None else 'public',
            "unique_name": obj.get("unique_name"),
            "data_users": obj.get("data_users"),
            "sessions": obj.get("sessions"),
            "create_ts": obj.get("create_ts"),
            "modify_ts": obj.get("modify_ts")
        })
        return _obj


